import java.io.*;
import java.util.*;
import java.math.*;

public class hadron_aa implements Runnable {

	public static void main(String[] args) {
		new Thread(new hadron_aa()).start();
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;
	boolean eof = false;
	Random rand = new Random(this.hashCode());

	@Override
	public void run() {
		long time = System.currentTimeMillis();
		Locale.setDefault(Locale.US);
		try {
			br = new BufferedReader(new FileReader(FNAME + ".in"));
			out = new PrintWriter(FNAME + ".out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(566);
		}
		System.out.println((System.currentTimeMillis() - time) / 1000.0);
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	void myAssert(boolean u, String message) {
		if (!u) {
			throw new Error("Assertion failed!!! " + message);
		}
	}

	int inBounds(int x, int l, int r, String name) {
		myAssert(l <= x && x <= r, name + " not in bounds!!! " + x
				+ " not in [" + l + ".." + r + "]");
		return x;
	}

	String FNAME = "hadron";

	private void solve() throws IOException {
		int n = inBounds(nextInt(), 1, 3, "n");
		int[] x = new int[n];
		int[] y = new int[n];
		int[] r = new int[n];
		for (int i = 0; i < r.length; i++) {
			x[i] = inBounds(nextInt(), -1000, 1000, "x[" + (i + 1) + "]");
			y[i] = inBounds(nextInt(), -1000, 1000, "y[" + (i + 1) + "]");
			r[i] = inBounds(nextInt(), 1, 1000, "r[" + (i + 1) + "]");
		}
		if (n == 1) {
			out.println((x[0] + r[0]) + " " + y[0] + " "
					+ (Math.sqrt(2) * r[0]));
			return;
		}
		long[] a = new long[n - 1];
		long[] b = new long[n - 1];
		long[] c = new long[n - 1];
		for (int i = 0; i < a.length; i++) {
			a[i] = 2 * (x[i + 1] - x[i]);
			b[i] = 2 * (y[i + 1] - y[i]);
			c[i] = x[i] * x[i] + y[i] * y[i] + r[i] * r[i] - x[i + 1]
					* x[i + 1] - y[i + 1] * y[i + 1] - r[i + 1] * r[i + 1];
		}
		if (n == 2) {
			double xa = -1.0 * a[0] * c[0] / (a[0] * a[0] + b[0] * b[0]);
			double ya = -1.0 * b[0] * c[0] / (a[0] * a[0] + b[0] * b[0]);
			double ra = Math.sqrt(r[0] * r[0] + dist(x[0], y[0], xa, ya));
			out.println(xa + " " + ya + " " + ra);
			return;
		}
		double d = a[0] * b[1] - a[1] * b[0];
		double xa = -(c[0] * b[1] - c[1] * b[0]) / d;
		double ya = -(a[0] * c[1] - a[1] * c[0]) / d;
		double ra = Math.sqrt(r[0] * r[0] + dist(x[0], y[0], xa, ya));
		out.println(xa + " " + ya + " " + ra);
	}

	private double dist(int x1, int y1, double x2, double y2) {
		return (x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2);
	}
}
